﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Web;
using System.Web.Services;

namespace ScheduleCRUDWithWebServices
{
    /// <summary>
    /// Summary description for WebService1
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    [System.Web.Script.Services.ScriptService]
    public class WebService1 : System.Web.Services.WebService
    {
        ScheduleDataDataContext db = new ScheduleDataDataContext();

        [WebMethod]
        public string HelloWorld()
        {
            return "Hello World";
        }


        [WebMethod]
        public List<Appointment> GetDatas()
        {           

            return db.Appointments.ToList();
        }
       

        [WebMethod]
        public List<Appointment> Crud(List<Appointment> added, List<Appointment> changed, List<Appointment> deleted)
        {
            ScheduleDataDataContext db = new ScheduleDataDataContext();
            int intMax = db.Appointments.ToList().Count > 0 ? db.Appointments.ToList().Max(p => p.Id) : 0;
            if (added != null && added.Count > 0)
            {
                var value = added[0];
                DateTime startTime = Convert.ToDateTime(value.StartTime);
                DateTime endTime = Convert.ToDateTime(value.EndTime);
                Appointment appoint = new Appointment();
                appoint.Id = intMax + 1;
                appoint.Subject = value.Subject;
                appoint.StartTime = startTime;
                appoint.EndTime = endTime;
                appoint.StartTimeZone = value.StartTimeZone;
                appoint.EndTimeZone = value.EndTimeZone;
                appoint.AllDay = value.AllDay;
                appoint.Description = value.Description;
                appoint.Recurrence = value.Recurrence;
                appoint.RecurrenceRule = value.RecurrenceRule;
                db.Appointments.InsertOnSubmit(appoint);
                db.SubmitChanges();
            }
            if (changed != null && changed.Count > 0)
            {
                var filterData = db.Appointments.Where(c => c.Id == Convert.ToInt32(changed[0].Id));
                if (filterData.Count() > 0)
                {
                    var value = changed[0];
                    DateTime startTime = Convert.ToDateTime(value.StartTime);
                    DateTime endTime = Convert.ToDateTime(value.EndTime);
                    Appointment appoint = db.Appointments.Single(A => A.Id == Convert.ToInt32(value.Id));
                    appoint.StartTime = startTime;
                    appoint.EndTime = endTime;
                    appoint.StartTimeZone = value.StartTimeZone;
                    appoint.EndTimeZone = value.EndTimeZone;
                    appoint.Subject = value.Subject;
                    appoint.Description = value.Description;
                    appoint.AllDay = value.AllDay;
                    appoint.Recurrence = value.Recurrence;
                    appoint.RecurrenceRule = value.RecurrenceRule;

                }
                db.SubmitChanges();
            }

            if (deleted != null && deleted.Count > 0)
            {
                foreach (Appointment dele in deleted)
                {
                    var app = db.Appointments.ToList().Where(c => c.Id == Convert.ToInt32(dele.Id)).FirstOrDefault();
                    if (app != null)
                    {
                        db.Appointments.DeleteOnSubmit(app);
                    }
                }
                db.SubmitChanges();
            }
            return db.Appointments.ToList();
        }
        [WebMethod]
        public List<Appointment> add(Appointment value)
        {
            ScheduleDataDataContext db = new ScheduleDataDataContext();

            int intMax = db.Appointments.ToList().Count > 0 ? db.Appointments.ToList().Max(p => p.Id) : 0;
            DateTime startTime = Convert.ToDateTime(value.StartTime);
            DateTime endTime = Convert.ToDateTime(value.EndTime);
            Appointment appoint = new Appointment()
            {
                Id = intMax + 1,
                StartTime = startTime,
                EndTime = endTime,
                StartTimeZone = value.StartTimeZone,
                EndTimeZone = value.EndTimeZone,
                Subject = value.Subject,
                AllDay = value.AllDay,
                Recurrence = value.Recurrence,
                RecurrenceRule = value.RecurrenceRule,


            };
            db.Appointments.InsertOnSubmit(appoint);
            db.SubmitChanges();
            return db.Appointments.ToList();
        }
        [WebMethod]
        public List<Appointment> remove(string key)
        {
            ScheduleDataDataContext db = new ScheduleDataDataContext();
            Appointment app = db.Appointments.Where(c => c.Id == Convert.ToInt32(key)).FirstOrDefault();

            if (app != null) db.Appointments.DeleteOnSubmit(app);
            db.SubmitChanges();
            return db.Appointments.ToList();
        }

        [WebMethod]
        public List<Appointment> update(Appointment value)
        {
            ScheduleDataDataContext db = new ScheduleDataDataContext();
            var filterData = db.Appointments.Where(c => c.Id == Convert.ToInt32(value.Id));
            if (filterData.Count() > 0)
            {
                DateTime startTime = Convert.ToDateTime(value.StartTime);
                DateTime endTime = Convert.ToDateTime(value.EndTime);
                Appointment appoint = db.Appointments.Single(A => A.Id == Convert.ToInt32(value.Id));
                appoint.StartTime = startTime;
                appoint.EndTime = endTime;
                appoint.StartTimeZone = value.StartTimeZone;
                appoint.EndTimeZone = value.EndTimeZone;
                appoint.Subject = value.Subject;
                appoint.AllDay = value.AllDay;
                appoint.Recurrence = value.Recurrence;
                appoint.RecurrenceRule = value.RecurrenceRule;
            }
            db.SubmitChanges();
            return db.Appointments.ToList();
        }

        public class EditParams
        {
            public string key { get; set; }
            public string action { get; set; }
            public  List<Appointment> added { get; set; }
            public  List<Appointment> changed { get; set; }
            public  List<Appointment> deleted { get; set; }
            public Appointment value { get; set; }
        }
   }
}
